<html>
<head>
<title>Ogre::Plane Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Plane.html">Plane</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Plane Class Reference<div class="ingroups"><a class="el" href="group__Math.html">Math</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Plane" -->
<p>Defines a plane in 3D space.  
 <a href="classOgre_1_1Plane.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::Plane:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1Plane__inherit__graph.gif" border="0" usemap="#Ogre_1_1Plane_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1Plane_inherit__map" id="Ogre_1_1Plane_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply..." alt="" coords="5,83,144,112"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1Plane-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a> { <a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaad112821a6c39f0097136ba5df53052a">NO_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5">POSITIVE_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e">NEGATIVE_SIDE</a>, 
<a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bca44420e1c49338ae721f298826e164935">BOTH_SIDE</a>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The "positive side" of the plane is the half space to which the plane normal points.  <a href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Plane</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Default constructor - sets everything to 0.  <a href="#a1530cc182a2a783e072eabe44f536149"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a1e298ca606c54a38ac5ea0df02282e62">Plane</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a296599d7461accceada20df86f7bd334">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> fConstant)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a plane through a normal, and a distance to move the plane along the normal.  <a href="#a296599d7461accceada20df86f7bd334"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a6bbbefc667888c438cfbe78aaf5a5ee3">Plane</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> a, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> b, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> c, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">d</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a plane using the 4 constants directly.  <a href="#a6bbbefc667888c438cfbe78aaf5a5ee3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#abd98e0aae4723943f83262e59cfda535">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#af8000ad8fdef98bcc7e21a9d194547a0">Plane</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint0, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint1, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint2)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#ae0131ee8cf1c09587c5cc4541c3b6297">getSide</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#ab60532827d305cb7848f540be2cfb66b">getSide</a> (const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;rkBox) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the side where the alignedBox is.  <a href="#ab60532827d305cb7848f540be2cfb66b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#aa8a0b3abc05dcc47ef7ce79d98fb8a99">getSide</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;centre, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;halfSize) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns which side of the plane that the given box lies on.  <a href="#aa8a0b3abc05dcc47ef7ce79d98fb8a99"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a9548b13f88e65d98ea08ba01c8f2fad1">getDistance</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a pseudodistance.  <a href="#a9548b13f88e65d98ea08ba01c8f2fad1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a3edb29b896bac43b3a199460123e94b2">redefine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint0, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint1, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint2)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Redefine this plane based on 3 points.  <a href="#a3edb29b896bac43b3a199460123e94b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a74dab1f3fb059277cd477aa683b238f7">redefine</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkNormal, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;rkPoint)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Redefine this plane based on a normal and a point.  <a href="#a74dab1f3fb059277cd477aa683b238f7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a54e83c81355e526a2b02d02625d42c4c">projectVector</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;v) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Project a vector onto the plane.  <a href="#a54e83c81355e526a2b02d02625d42c4c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a090aae792b4fecc6e8b1b5810f029edf">normalise</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalises the plane.  <a href="#a090aae792b4fecc6e8b1b5810f029edf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a06e8f4ea4698c322580c4299f6a12e07">operator==</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparison operator.  <a href="#a06e8f4ea4698c322580c4299f6a12e07"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#adae7d1d5d43cbe44cd40fc1e86784268">operator!=</a> (const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;rhs) const </td></tr>
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">normal</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">d</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plane.html#a3a3cc401219af46e986952c5f6bc7959">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;p)</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Defines a plane in 3D space. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A plane is defined in 3D space by the equation Ax + By + Cz + D = 0 </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This equates to a vector (the normal of the plane, whose x, y and z components equate to the coefficients A, B and C respectively), and a constant (D) which is the distance along the normal you have to go to move the plane back to the origin. </dd></dl>

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00061">61</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>
</div><hr/><h2>Member Enumeration Documentation</h2>
<a class="anchor" id="aa5d44b14d6f032f3e0a26e83589180bc"></a><!-- doxytag: member="Ogre::Plane::Side" ref="aa5d44b14d6f032f3e0a26e83589180bc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Ogre::Plane::Side</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The "positive side" of the plane is the half space to which the plane normal points. </p>
<p>The "negative side" is the other half space. The flag "no side" indicates the plane itself. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="aa5d44b14d6f032f3e0a26e83589180bcaad112821a6c39f0097136ba5df53052a"></a><!-- doxytag: member="NO_SIDE" ref="aa5d44b14d6f032f3e0a26e83589180bcaad112821a6c39f0097136ba5df53052a" args="" -->NO_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5"></a><!-- doxytag: member="POSITIVE_SIDE" ref="aa5d44b14d6f032f3e0a26e83589180bcac5f2b56ac439b77aad6dfc4031891be5" args="" -->POSITIVE_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e"></a><!-- doxytag: member="NEGATIVE_SIDE" ref="aa5d44b14d6f032f3e0a26e83589180bcaaf227c36d02442779fd4600d00580f5e" args="" -->NEGATIVE_SIDE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="aa5d44b14d6f032f3e0a26e83589180bca44420e1c49338ae721f298826e164935"></a><!-- doxytag: member="BOTH_SIDE" ref="aa5d44b14d6f032f3e0a26e83589180bca44420e1c49338ae721f298826e164935" args="" -->BOTH_SIDE</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00080">80</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a1530cc182a2a783e072eabe44f536149"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="a1530cc182a2a783e072eabe44f536149" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Default constructor - sets everything to 0. </p>

</div>
</div>
<a class="anchor" id="a1e298ca606c54a38ac5ea0df02282e62"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="a1e298ca606c54a38ac5ea0df02282e62" args="(const Plane &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a296599d7461accceada20df86f7bd334"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="a296599d7461accceada20df86f7bd334" args="(const Vector3 &amp;rkNormal, Real fConstant)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>fConstant</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a plane through a normal, and a distance to move the plane along the normal. </p>

</div>
</div>
<a class="anchor" id="a6bbbefc667888c438cfbe78aaf5a5ee3"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="a6bbbefc667888c438cfbe78aaf5a5ee3" args="(Real a, Real b, Real c, Real d)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>c</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Construct a plane using the 4 constants directly. </p>

</div>
</div>
<a class="anchor" id="abd98e0aae4723943f83262e59cfda535"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="abd98e0aae4723943f83262e59cfda535" args="(const Vector3 &amp;rkNormal, const Vector3 &amp;rkPoint)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="af8000ad8fdef98bcc7e21a9d194547a0"></a><!-- doxytag: member="Ogre::Plane::Plane" ref="af8000ad8fdef98bcc7e21a9d194547a0" args="(const Vector3 &amp;rkPoint0, const Vector3 &amp;rkPoint1, const Vector3 &amp;rkPoint2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#a1530cc182a2a783e072eabe44f536149">Ogre::Plane::Plane</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a9548b13f88e65d98ea08ba01c8f2fad1"></a><!-- doxytag: member="Ogre::Plane::getDistance" ref="a9548b13f88e65d98ea08ba01c8f2fad1" args="(const Vector3 &amp;rkPoint) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Plane.html#a9548b13f88e65d98ea08ba01c8f2fad1">Ogre::Plane::getDistance</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This is a pseudodistance. </p>
<p>The sign of the return value is positive if the point is on the positive side of the plane, negative if the point is on the negative side, and zero if the point is on the plane. </p>
<dl class="user"><dt><b></b></dt><dd>The absolute value of the return value is the true distance only when the plane normal is a unit length vector. </dd></dl>

<p>Referenced by <a class="el" href="OgrePlaneBoundedVolume_8h_source.html#l00095">Ogre::PlaneBoundedVolume::intersects()</a>.</p>

</div>
</div>
<a class="anchor" id="ae0131ee8cf1c09587c5cc4541c3b6297"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="ae0131ee8cf1c09587c5cc4541c3b6297" args="(const Vector3 &amp;rkPoint) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a> <a class="el" href="classOgre_1_1Plane.html#ae0131ee8cf1c09587c5cc4541c3b6297">Ogre::Plane::getSide</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Referenced by <a class="el" href="OgrePlaneBoundedVolume_8h_source.html#l00064">Ogre::PlaneBoundedVolume::intersects()</a>.</p>

</div>
</div>
<a class="anchor" id="ab60532827d305cb7848f540be2cfb66b"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="ab60532827d305cb7848f540be2cfb66b" args="(const AxisAlignedBox &amp;rkBox) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a> <a class="el" href="classOgre_1_1Plane.html#ae0131ee8cf1c09587c5cc4541c3b6297">Ogre::Plane::getSide</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td>
          <td class="paramname"><em>rkBox</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the side where the alignedBox is. </p>
<p>The flag BOTH_SIDE indicates an intersecting box. One corner ON the plane is sufficient to consider the box and the plane intersecting. </p>

</div>
</div>
<a class="anchor" id="aa8a0b3abc05dcc47ef7ce79d98fb8a99"></a><!-- doxytag: member="Ogre::Plane::getSide" ref="aa8a0b3abc05dcc47ef7ce79d98fb8a99" args="(const Vector3 &amp;centre, const Vector3 &amp;halfSize) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html#aa5d44b14d6f032f3e0a26e83589180bc">Side</a> <a class="el" href="classOgre_1_1Plane.html#ae0131ee8cf1c09587c5cc4541c3b6297">Ogre::Plane::getSide</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>centre</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>halfSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns which side of the plane that the given box lies on. </p>
<p>The box is defined as centre/half-size pairs for effectively. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">centre</td><td>The centre of the box. </td></tr>
    <tr><td class="paramname">halfSize</td><td>The half-size of the box. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>POSITIVE_SIDE if the box complete lies on the "positive side" of the plane, NEGATIVE_SIDE if the box complete lies on the "negative side" of the plane, and BOTH_SIDE if the box intersects the plane. </dd></dl>

</div>
</div>
<a class="anchor" id="a090aae792b4fecc6e8b1b5810f029edf"></a><!-- doxytag: member="Ogre::Plane::normalise" ref="a090aae792b4fecc6e8b1b5810f029edf" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Plane.html#a090aae792b4fecc6e8b1b5810f029edf">Ogre::Plane::normalise</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Normalises the plane. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method normalises the plane's normal and the length scale of d is as well. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This function will not crash for zero-sized vectors, but there will be no changes made to their components. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The previous length of the plane's normal. </dd></dl>

</div>
</div>
<a class="anchor" id="adae7d1d5d43cbe44cd40fc1e86784268"></a><!-- doxytag: member="Ogre::Plane::operator!=" ref="adae7d1d5d43cbe44cd40fc1e86784268" args="(const Plane &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Plane::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00152">152</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h_source.html#l00145">d</a>, and <a class="el" href="OgrePlane_8h_source.html#l00144">normal</a>.</p>

</div>
</div>
<a class="anchor" id="a06e8f4ea4698c322580c4299f6a12e07"></a><!-- doxytag: member="Ogre::Plane::operator==" ref="a06e8f4ea4698c322580c4299f6a12e07" args="(const Plane &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Plane::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Comparison operator. </p>

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00148">148</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>

<p>References <a class="el" href="OgrePlane_8h_source.html#l00145">d</a>, and <a class="el" href="OgrePlane_8h_source.html#l00144">normal</a>.</p>

</div>
</div>
<a class="anchor" id="a54e83c81355e526a2b02d02625d42c4c"></a><!-- doxytag: member="Ogre::Plane::projectVector" ref="a54e83c81355e526a2b02d02625d42c4c" args="(const Vector3 &amp;v) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Plane.html#a54e83c81355e526a2b02d02625d42c4c">Ogre::Plane::projectVector</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Project a vector onto the plane. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This gives you the element of the input vector that is perpendicular to the normal of the plane. You can get the element which is parallel to the normal of the plane by subtracting the result of this method from the original vector, since parallel + perpendicular = original. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">v</td><td>The input vector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3edb29b896bac43b3a199460123e94b2"></a><!-- doxytag: member="Ogre::Plane::redefine" ref="a3edb29b896bac43b3a199460123e94b2" args="(const Vector3 &amp;rkPoint0, const Vector3 &amp;rkPoint1, const Vector3 &amp;rkPoint2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Plane.html#a3edb29b896bac43b3a199460123e94b2">Ogre::Plane::redefine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Redefine this plane based on 3 points. </p>

</div>
</div>
<a class="anchor" id="a74dab1f3fb059277cd477aa683b238f7"></a><!-- doxytag: member="Ogre::Plane::redefine" ref="a74dab1f3fb059277cd477aa683b238f7" args="(const Vector3 &amp;rkNormal, const Vector3 &amp;rkPoint)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1Plane.html#a3edb29b896bac43b3a199460123e94b2">Ogre::Plane::redefine</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkNormal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>rkPoint</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Redefine this plane based on a normal and a point. </p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="a3a3cc401219af46e986952c5f6bc7959"></a><!-- doxytag: member="Ogre::Plane::operator&lt;&lt;" ref="a3a3cc401219af46e986952c5f6bc7959" args="(std::ostream &amp;o, const Plane &amp;p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Plane.html">Plane</a> &amp;&#160;</td>
          <td class="paramname"><em>p</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a8e7de1712320968bee111002bc2938b8"></a><!-- doxytag: member="Ogre::Plane::d" ref="a8e7de1712320968bee111002bc2938b8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1Plane.html#a8e7de1712320968bee111002bc2938b8">Ogre::Plane::d</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00145">145</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>

<p>Referenced by <a class="el" href="OgrePlane_8h_source.html#l00152">operator!=()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00237">Ogre::Matrix4::operator*()</a>, and <a class="el" href="OgrePlane_8h_source.html#l00148">operator==()</a>.</p>

</div>
</div>
<a class="anchor" id="a3f97462d3822f6add8c070048f6c2d92"></a><!-- doxytag: member="Ogre::Plane::normal" ref="a3f97462d3822f6add8c070048f6c2d92" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> <a class="el" href="classOgre_1_1Plane.html#a3f97462d3822f6add8c070048f6c2d92">Ogre::Plane::normal</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePlane_8h_source.html#l00144">144</a> of file <a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a>.</p>

<p>Referenced by <a class="el" href="OgrePlane_8h_source.html#l00152">operator!=()</a>, <a class="el" href="OgreMatrix4_8h_source.html#l00237">Ogre::Matrix4::operator*()</a>, and <a class="el" href="OgrePlane_8h_source.html#l00148">operator==()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePlane_8h_source.html">OgrePlane.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
